package com.liang.service;

import com.liang.entity.StaExpertFee;
import com.liang.entity.StaIntellectualProperty;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 专家咨询费(StaExpertFee)表服务接口
 */
public interface StaExpertFeeService {
    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaExpertFee queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staExpertFee 筛选条件
     * @param pageRequest  分页对象
     * @return 查询结果
     */
    Page<StaExpertFee> queryByPage(StaExpertFee staExpertFee, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staExpertFee 实例对象
     * @return 实例对象
     */
    int insert(StaExpertFee staExpertFee);

    /**
     * 修改数据
     *
     * @param staExpertFee 实例对象
     * @return 实例对象
     */
    int update(StaExpertFee staExpertFee);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除专家咨询费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入专家咨询费
     *
     * @param expenseList
     * @return
     */
    int insertBatch(List<StaExpertFee> expenseList);

    /**
     * 获取专家咨询费列表
     *
     * @return
     */
    List<StaExpertFee> getZjfList(Integer zb);

    List<StaExpertFee> queryByKyfh(String kyfh);

    /**
     * @param MC   项目名称
     * @param ZJXM 专家姓名
     * @param ZC   职称
     * @param QSRQ 创建起始日期
     * @param JZRQ 创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchTemeMemberCost(Map map);
}
